package com.telpo.dipperposition.common;

import com.csvreader.CsvReader;
import com.csvreader.CsvWriter;

import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.nio.charset.Charset;
import java.util.ArrayList;
import java.util.List;
/**
 * @program: dipperposition
 * @description: CSV文件读取单元
 * @author: linwl
 * @create: 2021-01-14 11:19
 **/
public class CSVUtil {
    /**
     * 读取每行的数据
     *
     * @param readPath
     * @return
     */
    public static List<String> readCSV(String readPath) {
        String filePath = readPath;
        List<String> listData = new ArrayList<>();
        try {
            filePath = readPath;
            CsvReader csvReader = new CsvReader(filePath,',',Charset.forName("UTF-8"));
            // 读表头
            boolean re = csvReader.readHeaders();
            while (csvReader.readRecord()) {
                String rawRecord = csvReader.getRawRecord();
                listData.add(rawRecord);
            }
            return listData;
        } catch (FileNotFoundException e) {
            throw new RuntimeException("文件未找到");
        } catch (IOException e) {
            throw new RuntimeException(e.getMessage());
        }

    }

    /**
     * 写入文件头
     * @param writePath
     * @param header
     */
    public static void writeCSV(String writePath, String[] header) {
        String filePath = writePath;
        try {
            CsvWriter csvWriter = new CsvWriter(writePath, ',', Charset.forName("UTF-8"));
            //String [] header = {"SkuId","SsuId","图片地址","大小(bit)","高度","宽度"};
            csvWriter.writeRecord(header);
            csvWriter.close();
        } catch (Exception e) {
            e.printStackTrace();
        }

    }

    /**
     * 利用输入输出流持续写
     * @param fileName
     * @param content
     */
    public static void writeContent(String fileName, String content) {
        FileWriter writer = null;
        try {
            // 打开一个写文件器，构造函数中的第二个参数true表示以追加形式写文件
            writer = new FileWriter(fileName, true);
            writer.write(content + "\r\n");
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            try {
                if (writer != null) {
                    writer.close();
                }
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }
}
